const fs = require('fs');
const path = require('path');
const _ = require('lodash/fp');

const recurseFiles = (file) => {
  const stats = fs.statSync(file);

  if (stats.isFile()) {
    return path.resolve(file);
  }

  if (stats.isDirectory()) {
    const files = fs.readdirSync(file);
    return files
      .map(basename => path.resolve(file, basename))
      .map(recurseFiles);
  }

  return undefined;
};

module.exports = function filesParser(files) {
  const fix = _.compose(
    _.filter(x => x.match(/\.js$/)),
    _.flattenDeep,
    _.map(recurseFiles),
  );

  return fix(files);
};
