const debug = require('debug');

const ONE_HOUR = 3600000;

module.exports = function initScraper(construct) {
  const scraperInstance = construct();

  scraperInstance.construct = construct;
  scraperInstance.timeBetween = scraperInstance.timeBetween || ONE_HOUR;

  if (typeof scraperInstance.timeBetween !== 'number') {
    throw new Error('timeBetween must be a number');
  }

  const logLevels = ['verbose', 'debug', 'log', 'warn', 'error'];

  scraperInstance.setLogPrefix = (prefix) => {
    logLevels.forEach((level) => {
      scraperInstance[level] = debug(`scraperjs:${level}:${prefix}:${scraperInstance.name}`);
    });
  };

  scraperInstance.setLogPrefix('boot');

  return scraperInstance;
};
