module.exports = function ezMetaConstructor() {
  const getMetaProperty = ($, name) =>
    $(`meta[property="${name}"]`).attr('content'); // eslint-disable-line no-undef

  const expands = {
    price: [
      'product:price:amount',
      'product:price',
    ],
    image: [
      'image:url',
    ],
  };

  function expandNames(name) {
    return [
      `og:${name}`,
      ...(expands[name] || []),
      ...(expands[name] || []).map(altName => `og:${altName}`),
    ];
  }

  return function ezMeta(name) {
    const expandedNames = [name, ...expandNames(name)];

    // eslint-disable-next-line no-restricted-syntax
    for (const check of expandedNames) {
      if (getMetaProperty($, check)) {
        return getMetaProperty($, check);
      }
    }

    return undefined;
  };
};
