module.exports = function getLDJsonConstructor() {
  function getLDJSON() {
    // eslint-disable-next-line no-restricted-syntax
    for (const script of $('script').toArray()) {
      const content = script.textContent
        .replace(/(?:\r|\n)/g, ' ')
        .replace(new RegExp(String.fromCodePoint(9), 'g'), ' ');
      try {
        const parsed = JSON.parse(content);
        if (parsed['@type'] && parsed['@type'].toLowerCase() === 'product') {
          return parsed;
        }
      } catch (e) {
        // silently ignore errors
        // console.log(e);
      }
    }
    return undefined;
  }

  return function ezSchema(name) {
    const sData = getLDJSON();

    if (sData === undefined) {
      return undefined;
    }

    if (name === 'price' && sData[name] === undefined) {
      if (sData.offers && sData.offers.price) {
        return sData.offers.price;
      }
    }

    if (name === 'availability') {
      if (sData.offers && sData.offers.availability) {
        return sData.offers.availability;
      }
    }

    return sData[name];
  };
};
